// ClassExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ClassExample.h"
#include "ClassExampleDlg.h"
#include "Model/TmyWorld.h"
#include "TmodelControl.h"
#include "Td3dDrawable.h"
#include "Td3dZoomDrawable.h"
#include "GraphicsAPI/Tcamera.h"
#include "TrawMeshSurfaceControl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}


#define kSliderScale	10.0f
#define kSliderFactor   (1.0f/kSliderScale)


BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClassExampleDlg dialog

CClassExampleDlg::CClassExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClassExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClassExampleDlg)
	m_StatusArea = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	fMyWorld = NULL;
	fMyCamera = NULL;
	fDrawable = NULL;
	fD3d = NULL;
	fControl = NULL;
	fRawMeshSurfaceControl = NULL;

	fZoomDrawable = NULL;
	fZoomCamera = NULL;
}

void CClassExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClassExampleDlg)
	DDX_Text(pDX, IDC_STATUS_AREA, m_StatusArea);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDCANCEL, m_QuitButton);
}

BEGIN_MESSAGE_MAP(CClassExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CClassExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDCANCEL, OnQuit)
	//}}AFX_MSG_MAP
	ON_WM_HSCROLL()
	ON_WM_SIZE()
END_MESSAGE_MAP()


void CClassExampleDlg::UpdateSliderEcho(
	CString	&echo,
	float	value
)
{
	echo.Format("%5.2f", value);
	UpdateData(FALSE);
}


float CClassExampleDlg::GetSliderBarValue(
	CSliderCtrl &slider
)
{
	return (slider.GetPos() * kSliderFactor);
}

void CClassExampleDlg::InitializeSlider(
	CSliderCtrl &slider,
	CString	    &echo,
	float		min,
	float		max,
	float		init
)
{
	slider.SetRange(int(min*kSliderScale), int(max*kSliderScale), TRUE);
	slider.SetPos(int(init*kSliderScale));
	UpdateSliderEcho(echo, init);
}


/////////////////////////////////////////////////////////////////////////////
// CClassExampleDlg message handlers

BOOL CClassExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	
	//*******************************************************************
	// Code added in by Kelvin are the following:
	//
	//	
	// Create the D3d object, which is needed to create the rest of the D3DDevices (Drawables)
	if( NULL == ( fD3d = Direct3DCreate9( D3D_SDK_VERSION ) ) ) {
		MessageBox("D3d Creation Failed (1)!");
		return FALSE;
	}

	//**************************************************************
	//
	// Credit: I learned the following trick of replacing the 
	//         place holder from Steve Baer (in CSS451, Winter 2002) 
	//		   [KS Aug 2002]
	//
	#define CreateDrawable(_newDrawable_, _placeHolder_, _drawableType_, _aspect)		\
	{																					\
		CWnd* pStatic = this->GetDlgItem(_placeHolder_);								\
		CRect staticRect;																\
		pStatic->GetWindowRect(&staticRect);											\
		pStatic->DestroyWindow();														\
		ScreenToClient(&staticRect);													\
		_newDrawable_ = new _drawableType_##();											\
		_aspect = float(staticRect.Width()) / float(staticRect.Height());				\
		if (!##_newDrawable_##->Create(NULL,  											\
						NULL,															\
						WS_CHILD|WS_CLIPSIBLINGS|WS_CLIPCHILDREN|WS_VISIBLE|WS_BORDER,	\
						staticRect,														\
						this,															\
						_placeHolder_) ) { 												\
			MessageBox("D3DX Device Creation Failed!!");								\
			return FALSE;																\
		}																				\
		if (!##_newDrawable_##->InitD3D(fD3d)) {										\
			MessageBox("D3D device initialization failed!");							\
		}																				\
	}


	float cameraAspect;
	CreateDrawable(fDrawable, IDC_D3DX_PLACEHOLDER, Td3dDrawable, cameraAspect)
	// CreateDrawable(fDrawable, IDC_D3DX_ZOOM_PLACEHOLDER, Td3dDrawable, cameraAspect)
  	fDrawable->BringWindowToTop();

	float zoomCameraAspect;
	CreateDrawable(fZoomDrawable, IDC_D3DX_ZOOM_PLACEHOLDER, Td3dZoomDrawable, zoomCameraAspect)
	// CreateDrawable(fZoomDrawable, IDC_D3DX_PLACEHOLDER, Td3dZoomDrawable, zoomCameraAspect)
  	fZoomDrawable->BringWindowToTop();

	#define CreateControlInArea(_placeHolder_, _newControl_, _controlTag_, _controlType_) {	\
		CWnd* pStatic = this->GetDlgItem(##_placeHolder_##);		\
		CRect staticRect;											\
		pStatic->GetWindowRect(&staticRect);						\
		pStatic->DestroyWindow();									\
		ScreenToClient(&staticRect);								\
		const CPoint &topLeft = staticRect.TopLeft();				\
		_newControl_ = new _controlType_##(this);					\
		if (!##_newControl_##->Create(##_controlTag_##,	this) ) {	\
				MessageBox("Circle Control Creation Failed!!");		\
				return FALSE;										\
		}															\
		##_newControl_##->SetWindowPos(NULL, 						\
					topLeft.x, topLeft.y,							\
					staticRect.Width(), staticRect.Height(), 		\
					0);												\
		##_newControl_##->BringWindowToTop();						\
	}
	CreateControlInArea(IDC_MODEL_CONTROL_PLACEHOLDER,    fControl, 	IDD_MODEL_CONTROL, TmodelControl)
	CreateControlInArea(IDC_RAW_MESH_SURFACE_CONTROL_PLACEHOLDER, fRawMeshSurfaceControl, IDD_RAW_MESH_SURFACE_CONTROL, TrawMeshSurfaceControl)

	fRawMeshSurfaceControl->SetMeshLibrary( &(fDrawable->fMeshSurfaceLibrary), &(fZoomDrawable->fMeshSurfaceLibrary) );
	fMyWorld = new TmyWorld();
	fMyWorld->SetControl(fControl);

#define kInitCameraFOV	M_PI/4.0

	fMyCamera = new Tcamera(D3DXVECTOR3(0, 35, 50),	// eye
							D3DXVECTOR3(0, 0, 0),	// at
							D3DXVECTOR3(0, 1, 0),	// up
							kInitCameraFOV,			// fov: PI/4 (45-degree) field of view
							cameraAspect, 			// computed during Drawable creation
							1.0f, 			// near clipping plane
							1000.0f );
	
	fZoomCamera = new Tcamera(D3DXVECTOR3(0, 50, 70),	// eye
							D3DXVECTOR3(0, 0, 0),	// at
							D3DXVECTOR3(0, 1, 0),	// up
							kInitCameraFOV,			// fov: PI/4 (45-degree) field of view
							zoomCameraAspect, 		// computed during Drawable creation
							1.0f, 			// near clipping plane
							1000.0f );
	
	fMyCamera->DisableShowRailGrid();

	fDrawable->SetMyWorld(fMyWorld);
	fZoomDrawable->SetMyWorld(fMyWorld);
	
	fDrawable->SetMyControl(fControl);
	fZoomDrawable->SetMyControl(fControl);

	fDrawable->SetMyCamera(fMyCamera);
	fZoomDrawable->SetMyCamera(fZoomCamera);
	fZoomDrawable->SetOtherCamera(fMyCamera);

	fControl->SetMyWorld(fMyWorld);
	fMyWorld->SetViewCamera(fMyCamera);
	UpdateData(FALSE);
	
	#ifdef DEBUG_RELEASE
		fDrawable->fMeshLibrary.PrintLibraryToLog("In ClassDlg");
	#endif

	// Resizing work ...
	//
	//
	// Now let's get sufficient information so we can 
	// move Quit button around;
	CRect quitRect;
	m_QuitButton.GetWindowRect(&quitRect);
	ScreenToClient(&quitRect);
	fQuitDistanceToEdge = fDialogWidth - (quitRect.TopLeft()).x;
	CString d;
	d.Format("Quit Distance is:%d (bottomy=%d)", fQuitDistanceToEdge, quitRect.BottomRight().y);
	EchoToStatusArea(d);

	// Now for Drawable, we want to be some constants away from the Control ...
	CRect ctrRect;
	fControl->GetWindowRect(&ctrRect);
	ScreenToClient(&ctrRect);
		// in this case, the top-most our Td3dDrawable should come is
		// some constant pixels lower than the quitButton ... remembering
		// y's origin is at the top most ...
		fDrawableTop = quitRect.BottomRight().y + 10;	// 10 pixels below quit button
		// in this case, the left most our Td3dDrawable should come is
		// some constant pixels left than the controlPanel ....
		fDrawableLeft = ctrRect.BottomRight().x + 10;

	const static int msInterval = 25;	// timer going off every 35 milli seconds.
  	SetTimer(0, msInterval, NULL);		// our goal is to approx 30 frames per second

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CClassExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClassExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClassExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////
void CClassExampleDlg::OnTimer(UINT nIDEvent) 
{
	if (fMyWorld != NULL)
		fMyWorld->UpdateWorld(*fDrawable);

	if (fDrawable != NULL) {

		fDrawable->RedrawDrawable();
		// this is the re-draw part of our system
		// notice: redraw NEVER EVER changes any system state.
	}

	if (fZoomDrawable != NULL) {
		fZoomDrawable->RedrawDrawable();
	}
}

void CClassExampleDlg::EchoToStatusArea(CString msg)
{
	m_StatusArea = msg;
	UpdateData(false);	// UpdateData(False) sends data to the control
						// UpdateData(True) gets data _FROM_ a control
}



BOOL CClassExampleDlg::PreTranslateMessage(MSG* pMsg) 
{
	switch (pMsg->message) {
		case WM_KEYDOWN:
			if ( OnKeyDown(pMsg->wParam) )
				return TRUE;	// we will _CONSUME_ this character and not let any other Dialog sees this			
		break;
	}
	return CDialog::PreTranslateMessage(pMsg);
}


bool CClassExampleDlg::OnKeyDown(UINT nChar) 
{
	bool consumed = false;
	//
	// the nChar passed in a "virtual-key codes"
	// look under MSDN for more detials, here
	// I am just going to decode a few that is important
	// to my application
	//
	//
	CString msg;

	switch (nChar) {
		case 'R':
			{
				fDrawable->ResetMouseRotation();
				fZoomDrawable->ResetMouseRotation();
				EchoToStatusArea("Reset Rotations");
				consumed = true;
			}
			break;
		case 'Q':
			{	OnQuit();
				EchoToStatusArea("Reset Rotations");
				consumed = true;
			}

		// default:
			// msg.Format("Key Down: (%c)", nChar);
			// EchoToStatusArea(msg);
	}
	return consumed;
}

void CClassExampleDlg::OnQuit() 
{
	KillTimer(0);

	
	SAFE_DELETE(fMyWorld)
	SAFE_DELETE(fMyCamera)
	SAFE_DELETE(fZoomCamera)
	
	SAFE_DELETE(fControl)
	SAFE_DELETE(fRawMeshSurfaceControl)

	SAFE_DELETE(fZoomDrawable)
	SAFE_DELETE(fDrawable)

	SAFE_RELEASE(fD3d)

	CDialog::OnCancel();		
}

void CClassExampleDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
}


void CClassExampleDlg::OnSize(UINT nType, int cx, int cy)
{
	CString	msg;
	
	fDialogWidth = cx;
	fDialogHeight = cy;

	if (fDrawable != NULL) {
		// OnSize is called the first time when the window was
		// created, with out the above test, we will be trying
		// to echo to CStatic (the statusArea) before the control
		// is created. 
		//
		// When fDrawable is not NULL, that means OnInitDialog
		// has been called, meaning we know all the controls
		// will be there ...
		//
		msg.Format("New ClassExampleDlg Size(%d %d) ", cx, cy);
		EchoToStatusArea(msg);	
		ComputeResizing();
	}

	CDialog::OnSize(nType, cx, cy);
}