#ifndef T_MESH_LIBRARY
#define T_MESH_LIBRARY

#include "../GraphicsAPI/GraphicsAPI.h"


////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  To add new mesh into the library do:
//
//    1. Add in a new index for the mesh in TmeshObjectIndex enum
//
//    2. copy the .x file to sfPathToMesh
//
//    3. add in an entry to the sfAllMeshes[] array with the new index and .x file name
//
//
////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
enum TmeshObjectIndex {
	eTigerMesh = 0,
	eCylinderMesh = 1,
	eConeMesh = 2,
	eTeapotMesh = 3,
	eShusuiMesh = 4,
	eCraftMesh = 5,
	eCarMesh = 6,
	eSphereMesh = 7,
	eBoxMesh = 8,

	// add before this
	eInvalidMesh = -1
};

class TrawMesh;

class TmeshLibrary {
		
	private:
		#define sfMeshLibrarySize 256

		TrawMesh	*fMeshLibrary[sfMeshLibrarySize];

	public:
		TmeshLibrary();
		~TmeshLibrary();


		void	 InitializeMeshLibrary(LPDIRECT3DDEVICE9,ID3DXMatrixStack*);

		void	 SetMeshToLibrary(TrawMesh *m, int i);
		TrawMesh *GetMeshFromLibrary(int index);
		
		#ifdef DEBUG_RELEASE
			void	 PrintLibraryToLog(const char*);
		#endif

};

#endif
