#include "TmeshSurfaceLibrary.h"
#include "TrawMeshSurface.h"


TmeshSurfaceLibrary::TmeshSurfaceLibrary() 
{
	fDevice = NULL;
	for (int i=0; i<sfMeshSurfaceLibrarySize; i++)
		fMeshSurfaceLibrary[i] = NULL;
}

TmeshSurfaceLibrary::~TmeshSurfaceLibrary()
{
	for (int i=0; i<sfMeshSurfaceLibrarySize; i++) 
		if ( fMeshSurfaceLibrary[i] != NULL )
			delete fMeshSurfaceLibrary[i];
}

void TmeshSurfaceLibrary::SetMeshSurfaceToLibrary(
		TrawMeshSurface *m, 
		int i)
{
	fMeshSurfaceLibrary[i] = m;
}


TrawMeshSurface *TmeshSurfaceLibrary::GetMeshSurfaceFromLibrary(int index) 
{
	#ifdef DEBUG_RELEASE
		CString msg;
		msg.Format("GetMeshSurfaceFromLibrary(i=%d ptr=%x)", index, fMeshSurfaceLibrary[index]);
		LogToFile(msg);
	#endif

	return fMeshSurfaceLibrary[index];
}

void TmeshSurfaceLibrary::CreateMeshSurface(
	int				  index,
	int				  resolution
)
{
	if (fMeshSurfaceLibrary[index] != NULL)
		delete fMeshSurfaceLibrary[index];

	fMeshSurfaceLibrary[index] = new TrawMeshSurface(fDevice, resolution);
}
