#include "TrawMeshSurface.h"
#include "../GraphicsAPI/Tline.h"
#include "../GraphicsAPI/Tpoint.h"

//
// virtual, this is overriding parent
void
TrawMeshSurface::DrawMeshSurface(Td3dDrawable &d)
{

	//
	// 1. make sure we load the new value of the selected vertex into the hardware ...
	//
	SetSelectedVertexToD3D();

	//
	// 2. Recompute Normal: this is VERY EXPENSIVE, should optimize in real application ...
	D3DXComputeNormals(fMesh, NULL);

	fMesh->DrawSubset(0);
}

void 
TrawMeshSurface::DrawNormalVectors(Td3dDrawable &d)
{
	Tline l;
	l.DisableLighting();
	Tmaterial &mt = l.GetMaterial();
	mt.SetEmissive(1, 1, 1);


	void *pVBuffer;
	fMesh->LockVertexBuffer( 0, &pVBuffer );
		TmyVertex *v = (TmyVertex *)pVBuffer;
		for (int i=0; i<fNumVertices; i++) {
			l.SetFirstVertex(v[i].fPoint.x, v[i].fPoint.y, v[i].fPoint.z);
			D3DXVECTOR3 p = v[i].fPoint + (v[i].fNormal * 0.1);
			l.SetSecondVertex(p.x, p.y, p.z);
			l.DrawObject(d);
		}
	fMesh->UnlockVertexBuffer();
}


void
TrawMeshSurface::DrawMeshControlGrid(Td3dDrawable &d)
{
	Tpoint sph;
	// sph.SetMeshIndex(eSphereMesh);
	sph.SetPointSize(4);
	sph.DisableLighting();
	Tmaterial &smt = sph.GetMaterial();
	smt.SetEmissive(0, 1, 0);
	// sph.SetScale(0.01);

	void *pVBuffer;
	fMesh->LockVertexBuffer( 0, &pVBuffer );
		TmyVertex *v = (TmyVertex *)pVBuffer;
		for (int i=0; i<fNumVertices; i++) {
			sph.SetLocationTo(v[i].fPoint.x, v[i].fPoint.y, v[i].fPoint.z);
			sph.DrawObject(d);
		}
	fMesh->UnlockVertexBuffer();

	//
	// Now draw the selected vertex ...
	if (fSelectedVertexIndex != kInvalidVertexIndex) {
		smt.SetEmissive(1, 0, 0);
		sph.SetPointSize(8);
		sph.SetLocationTo(fSelectedVertex.x, fSelectedVertex.y, fSelectedVertex.z);
		sph.DrawObject(d);
	}

}
