#include "Ttexture.h"

Ttexture::~Ttexture()
{
	if (fTexture != NULL)
		fTexture->Release();
}

Ttexture::Ttexture(LPDIRECT3DDEVICE9 pd3dDevice)
{
	fTexture = NULL;
	fD3dDevice = pd3dDevice;
}

LPDIRECT3DTEXTURE9
Ttexture::GetTexture()
{
	return fTexture;
}

void Ttexture::ActivateTexture(DWORD stage)
{
	if (fTexture == NULL)
		return;

  	// set up our texture stages for blending with file texture's alpha channel
	//
	//
	// For fire texture, ADDSMOOTH looks better:
	//
	//		result = Arg1 + (1-Arg1) * Arg2;
	// we want to do the above for all channels (so we cannot really use
	// alpha to help us blend)
	//
  	fD3dDevice->SetTextureStageState( stage, D3DTSS_COLORARG1, D3DTA_TEXTURE );
  	fD3dDevice->SetTextureStageState( stage, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
  	fD3dDevice->SetTextureStageState( stage, D3DTSS_COLOROP,   D3DTOP_BLENDTEXTUREALPHA);
	// fD3dDevice->SetTextureStageState( stage, D3DTSS_COLOROP,   D3DTOP_ADDSMOOTH);

	fD3dDevice->SetTextureStageState( stage, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);

	//
	// fD3dDevice->SetTextureStageState( stage, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG2);
	//
	//   What would happen if we choose ALPAH from Arg2? Try it with AlphaBlending on
	//   and figure out what is going on.
	//

	fD3dDevice->SetTexture(stage, fTexture);
}

void Ttexture::DeActivateTexture(DWORD stage)
{
	//
	// Is this the right way to deactivate texture?
	//
	fD3dDevice->SetTexture(stage, NULL);

	//
	// I think this is a better way to disable texture?
	fD3dDevice->SetTextureStageState( stage, D3DTSS_COLOROP,   D3DTOP_DISABLE);
}
