#include "TtextureLibrary.h"
#include "TfileTexture.h"

struct TtextureDesc {
	int		fTextureIndex;
	char*	fTextureName;
};


static TtextureDesc sfAllTextures[] =  {
		{eCMMRTexture, 				"CMMR.png"},
		{eKelvinInOfficeTexture, 	"KelvinInOffice.png"},
		{eTigerTexture, 			"tiger.png"},

		//
		// add new entries above this last one
		//
		{eInvalidTexture,			""}
};

#define sfPathToTexture "./TextureFiles/"


TtextureLibrary::TtextureLibrary() 
{
	for (int i=0; i<sfTextureLibrarySize; i++)
		fTextureLibrary[i] = NULL;
}

TtextureLibrary::~TtextureLibrary()
{
	for (int i=0; i<sfTextureLibrarySize; i++) 
		if ( fTextureLibrary[i] != NULL )
			delete fTextureLibrary[i];
}


void TtextureLibrary::SetTextureToLibrary(
	Ttexture *t,
	int i
)
{
	fTextureLibrary[i] = t;
}


Ttexture*
TtextureLibrary::GetTextureFromLibrary(
	int i
)
{
	return fTextureLibrary[i];
}



void TtextureLibrary::InitializeTextureLibrary(
	LPDIRECT3DDEVICE9 pDevice
)
{
	int i = 0;
	while (sfAllTextures[i].fTextureIndex != eInvalidTexture) {
		int index = sfAllTextures[i].fTextureIndex;
		TfileTexture *t = new TfileTexture(pDevice);
		if ( !t->LoadTexture(pDevice, sfPathToTexture, sfAllTextures[i].fTextureName) ) {
			CString msg;
			msg.Format("Loading of texture:[%s] from [%s] failed!", sfAllTextures[i].fTextureName, sfPathToTexture);
			WarningBox(msg);
			delete t;
		} else {
			fTextureLibrary[index] = t;
		}
		i++;
	}
}
