#include "Tcamera.h"

void  Tcamera::RotateCameraY(
	float dx
)
{
	// 1. rotate in the direction of fW by certain -dx degree ...
	//     in the fW direction, this is rotation wrt to fU vector
	// 
	// we DO NOT want to rotate wrt to fU, but then, what are we rotating wrt?
	if ( (dx != 0.0) && (fV.y != 0.0) ) {
		D3DXMATRIX m;
		float sign = 1.0f;
		if (D3DXVec3Dot(&sfYAxis, &fU) < 0) {
			sign = -1.0f;
		}
		D3DXVECTOR3 axis = sfYAxis * sign;

		D3DXMatrixRotationAxis(&m, &axis, -dx);
		D3DXVec3TransformNormal(&fV, &fV, &m);

		D3DXVECTOR3 v(fV.x, 0, fV.z);

		D3DXVec3Cross(&fW, &axis, &v);
		D3DXVec3Normalize(&fW, &fW);
		//
		// Get the new new U vector 
		D3DXVec3Cross(&fU, &fV, &fW);
		D3DXVec3Normalize(&fU, &fU);
		fUpVector = fU;
		UpdatePosition();
	}	
}

	
void  Tcamera::RotateCameraX(
	float dy
)
{
	if (dy != 0.0) {
		// 2. now rotate in the direction of fU by certain dy degree
		//			fU direction rotation is wrt to fW
		D3DXMATRIX m;
		D3DXMatrixRotationAxis(&m, &fW, dy);
		D3DXVec3TransformNormal(&fV, &fV, &m);
		D3DXVec3TransformNormal(&fU, &fU, &m);
		//
		// Get the new new W vector 
		D3DXVec3Cross(&fW, &fU, &fV);
		D3DXVec3Normalize(&fW, &fW);
		fUpVector = fU;

		UpdatePosition();
	}
}
