#ifndef TCIRCLE_H
#define TCIRCLE_H

#include "Tfillable.h"

#define sfNumVertices 100

	// 
	//
class Tcircle : public Tfillable {
	private:
		TmyVertex	fV[sfNumVertices];

	protected:
		void InitializeCircleObject();

		//
		// from TgraphicsObject
		//
		virtual void DrawObjectGeom(Td3dDrawable&, LPDIRECT3DDEVICE9);
		
	public:
		// good idea to always include constructor ...
		//
		Tcircle();

		Tcircle(const D3DXVECTOR3 &pt, float radius) {
			InitializeCircleObject();
			SetCenter(pt);
			SetRadius(radius);
		}

		void SetCenter(const D3DXVECTOR3 &pt) { fXformInfo.SetMovement(pt); }
		void SetCenter(float x, float y, float z) { fXformInfo.SetMovement(x, y, z); }
		void SetRadius(float r) { fXformInfo.SetScale(r); }

		float GetRadius() const { return fXformInfo.ScaleX(); } // since x and y are the same 
		const D3DXVECTOR3& GetCenter() const { return fXformInfo.Movement(); }
};

#endif
