#ifndef TDIRECTIONAL_LIGHT
#define TDIRECTIONAL_LIGHT

#include "Tlight.h"
#include "Tarrow.h"

class TdirectionalLight : public Tlight {
	private:
		Tarrow		fArrow;
	
	protected:
		//
		// from TgraphicsObject
		virtual void DrawObjectGeom(Td3dDrawable&, LPDIRECT3DDEVICE9);

	public:

		TdirectionalLight(int);

		virtual void GetLightPosition(D3DXVECTOR4 &pos) const {
			D3DXVECTOR3 dir;
			GetLightDirection(dir);
			pos.x = -dir.x;
			pos.y = -dir.y;
			pos.z = -dir.z;
			pos.w = 0.0;
		}
};

#endif
