#include "TdrawableObject.h"
#include "../Td3dDrawable.h"

TdrawableObject::TdrawableObject()
{
	InitializeDrawableObject();
}

ImplementSimpleObjAttr(TdrawableObject, WORD, ShadedMode)
ImplementBoolObjAttr(TdrawableObject, ShowNormalVectors)

void TdrawableObject::SetDrawColor(const D3DXCOLOR &c)
{
	fMaterial.SetEmissive(c);
	// fMaterial.SetDiffuse(c);
	// fMaterial.SetSpecular(c);
	// fMaterial.SetAmbient(c);
}

void TdrawableObject::InitializeDrawableObject()
{
	fShadedMode = D3DSHADE_GOURAUD;
	fShowNormalVectors = false;
}

void TdrawableObject::SetObjectD3DAttributes(
	Td3dDrawable &d)
{
	LPDIRECT3DDEVICE9 device = d.D3DDevice();
	device->SetRenderState(D3DRS_SHADEMODE,   fShadedMode);

	if (fLighting) {
		fMaterial.SetD3DMaterial(device);
	} else {
		D3DXCOLOR c;
		fMaterial.GetEmissive(c);
		sfNoLightMat.SetEmissive(c);
	
		// Set alpha of Diffuse
		c.r = c.g = c.b = 0.0f;
		sfNoLightMat.SetDiffuse(c);
		sfNoLightMat.SetD3DMaterial(device);
	}
			
}
