#ifndef TMY_VERTEX_H
#define TMY_VERTEX_H

#include "GraphicsAPI.h"

typedef  VOID* TvertexBufferPtr;

struct TmyVertex {
	D3DXVECTOR3		fPoint;			// vertex position
	D3DXVECTOR3		fNormal;		// vertex normal
	FLOAT			fU,  fV;		// for texture coordinates (for stage 0)
	FLOAT			fU1, fV1;		// texture coordinates (for stage 1)
};


#define kMyVertexFormat (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_TEX2)
	//
	// FVF flags D3DFVF_XXXX where XXXX is one of the following ...
	//
	// vertices: (XYZ - three floats)
	//
	// 		XYZ 	- untransformed vertex (WILL go through transformation stack)
	//		NORMAL	- untransformed normal vector (also xyz)
	//
	// texture: 2 sets of 2 floats
	//			to support two stage multitexturing, 
	//			we need to have two sets of texture coordinate per Vertex
	//		
	//		TEX2: says two sets of texture coordinate are presented		


#endif
