#include "TobjectList.h"
#include "T2dBound.h"


TobjectList::TobjectList()
{
}

void TobjectList::InsertObject(TgraphicsObject *o) { fTheList.push_back(o); }
int  TobjectList::ListLength() const { return fTheList.size(); }
bool TobjectList::ListIsEmpty() const { return fTheList.empty(); }
bool TobjectList::ListIsNotEmpty() const { return (!fTheList.empty()); }



void TobjectList::UpdateLocation()
{
	if (ListIsEmpty())
		return;

	list<TgraphicsObject*>::iterator it;

	it = fTheList.begin();
	while ( it != fTheList.end() ) {
		(*it)->UpdateLocation();
		++it;
	}
	return;
}

void TobjectList::DrawObjectGeom(
	Td3dDrawable &d,
	LPDIRECT3DDEVICE9) 
{
	if (ListIsEmpty())
		return;

	list<TgraphicsObject*>::iterator it;

	it = fTheList.begin();
	while ( it != fTheList.end() ) {
		(*it)->DrawObject(d);
		++it;
	}
	return;
}

void TobjectList::DeleteObject(
	TgraphicsObject *obj)
{
	fTheList.remove(obj);
		// this will remove the link from the link list
		//

	delete obj;
		// now we free the memory for TgraphicsObject
}

void TobjectList::EraseList()
{
	if (ListIsEmpty())
		return;

	list<TgraphicsObject*>::iterator it;

	it = fTheList.begin();
	while ( it != fTheList.end() ) {
		DeleteObjectAtIterator(it);
	}
	return;
}

void TobjectList::DeleteObjectAtIterator(
	list<TgraphicsObject*>::iterator &it
)
{
	// 1. get the TgraphicsObject and delete it
		TgraphicsObject *obj = *it;
		delete obj;

	// 2. Set up to get the next iterator position
	list<TgraphicsObject*>::iterator next = it;
	next++;

	// 3. delete this iterator position from the list;
	fTheList.erase(it);

	// 4. return the next position in the link list;
	it = next;
}
