#ifndef TOBJECT_LIST_H
#define TOBJECT_LIST_H

#include <list>
			// STL list class
			//

#include "TgraphicsObject.h"

using namespace std;

class T2dBound;
class TobjectList : public TgraphicsObject {
		//
		// notice TobjectList is a subclass of TgraphicsObject
		// this says, we must define all the pure virtual functions
		// defined in TgraphicsObject. More importantly, we are saying
		// TobjectList is also a TgraphicsObject, meaning we will be 
		// able to "DrawSelf()" on this list ... this is a powerful
		// concept, it may not be so obvious at this point, but when
		// we start to Group/Ungroup objects, this list will become
		// a fundamental tool.
		//
		//

	private:

	protected:

		//
		//
				bool	ListIsEmpty() const;
				bool	ListIsNotEmpty() const;

				//
				// From TgraphicsObject
				//
				virtual void 	DrawObjectGeom(Td3dDrawable&, LPDIRECT3DDEVICE9);

	public:
				TobjectList();

				//
				// from TgraphicsObject
				virtual void UpdateLocation();

				list<TgraphicsObject*> fTheList;
						//
						// inserting a graphics object to the end of the list
						//
				void 	InsertObject(TgraphicsObject *obj);
				int		ListLength() const;


				void EraseList();
								// remove everything in the list and free up all
								// associated memory
								//
				void DeleteObject(TgraphicsObject *obj);	
								// This is an order-n deletion, will free the memory
								// of obj. Meanning caller should not refer to obj-pointer
								// after calling this function
								//
				void DeleteObjectAtIterator(list<TgraphicsObject*>::iterator &it);
								// order-1 operation, will handle the freeing of
								// TgraphicsObject, and after the deletion
								// iterator points to the next element in the list

};
#endif
