#ifndef T_OFFSET_MESH
#define T_OFFSET_MESH

#include "../GraphicsAPI/Tmesh.h"

class ToffsetMesh : public TgraphicsObject {
	private:

	protected:

		Tmesh		fObject;

		D3DXVECTOR3	fRefPos;

			//
			// from TgraphicsObject
			virtual void DrawObjectGeom(Td3dDrawable&, LPDIRECT3DDEVICE9);
			virtual void SetObjectD3DAttributes(Td3dDrawable &d);
			virtual bool RayPickObjectGeom(Td3dDrawable &d, LPDIRECT3DDEVICE9 p,
							const D3DXVECTOR3 &o, const D3DXVECTOR3 &dir) { 
								return fObject.RayPickObject(d,o,dir); }


	public:
			//
			// from TgraphicsObject
			virtual void SetObjectD3DTransformation(ID3DXMatrixStack *stack) const;
			virtual Tmaterial& GetMaterial() { return fObject.GetMaterial(); }
			virtual void SetMaterial(const Tmaterial &na) { fObject.SetMaterial(na); }

		ToffsetMesh();
		ToffsetMesh(TmeshObjectIndex i);

		void SetMeshIndex(TmeshObjectIndex i) { fObject.SetMeshIndex(i); }

		TgraphicsObject *GetObject() { return &fObject; }
		const TgraphicsObject *GetObject() const { return &fObject; }

		void SetReferencePos(float x, float y, float z) {
			fRefPos.x = x;
			fRefPos.y = y;
			fRefPos.z = z;
		}

		virtual void EnableLighting() {	TgraphicsObject::EnableLighting(); fObject.EnableLighting(); }
		virtual void DisableLighting() {TgraphicsObject::DisableLighting(); fObject.DisableLighting();}
		virtual bool LightingIsEnabled() const { return fObject.LightingIsEnabled(); }

			// Alpha Blending
		virtual void EnableAlphaBlending() { TgraphicsObject::EnableAlphaBlending(); fObject.EnableAlphaBlending();	}
		virtual void DisableAlphaBlending() {TgraphicsObject::DisableAlphaBlending(); fObject.DisableAlphaBlending(); }
		virtual bool AlphaBlendingIsEnabled() const { return fObject.AlphaBlendingIsEnabled(); } 
};

#endif
