#if !defined(AFX_TD3DDRAWABLE_H__C2CBA7C9_F645_4E20_8CB6_4CBB67E7FDC7__INCLUDED_)
#define AFX_TD3DDRAWABLE_H__C2CBA7C9_F645_4E20_8CB6_4CBB67E7FDC7__INCLUDED_


#pragma once
//
// Td3dDrawable.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// Td3dDrawable window


#include "./GraphicsAPI/GraphicsAPI.h"
		// 
		// D3D includes are handled in GraphicsAPI.h
		//

#include "./Collections/TmeshLibrary.h"
#include "./Collections/TmeshSurfaceLibrary.h"
#include "./Collections/TtextureLibrary.h"
#include "./GraphicsAPI/Tvaluator.h"

class TmyWorld;
class Tcamera;
class TmodelControl;
class Td3dDrawable : public CWnd
{
// Construction
public:
	Td3dDrawable();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(Td3dDrawable)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~Td3dDrawable();

	// Generated message map functions
protected:
	//{{AFX_MSG(Td3dDrawable)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
//
//******************************************************************************
//
// Except the "#inlcude "GraphicsAPI.h" all above code are generated by 
// MFC's class widzard. Our code start from here.
//
//******************************************************************************

	public:
			BOOL	InitD3D(LPDIRECT3D9);
							// this function defined in Td3dDrawable_Init.cpp
							//

	        void	RedrawDrawable();
							// this function defined in Td3dDrawable_Draw.cpp
							//
					
			void 	ResetMouseRotation();


			LPDIRECT3DDEVICE9 D3DDevice();
			ID3DXMatrixStack *Obj2WldStack();
		

			void	SetMyWorld(TmyWorld *w);
			void	SetMyCamera(Tcamera *c);
			void	SetMyControl(TmodelControl *c) { fMyControl = c; }
			void	SetDrawableSize(int w, int h);


			// convenient location for texture and mesh library support
			//
			TmeshLibrary		fMeshLibrary;
			TmeshSurfaceLibrary fMeshSurfaceLibrary;
			TtextureLibrary 	fTextureLibrary;

	protected:
	
	virtual	void DrawableSpecificDraw() {}
	virtual	void DrawableSpecificInitDraw() {}
	virtual	void DrawableSpecificRestoreDraw() {}


			int					fWidth;
			int					fHeight;

			//
			// D3D Device
			LPDIRECT3DDEVICE9	fD3dDevice;		// the abstrac D3D device

			ID3DXMatrixStack	*fObj2WorldStack;	// D3D let us create and maintain any number of
													// matrix stacks. We push/pop this stacks to implement
													// coordinate transformations

			TmyWorld		*fMyWorld;			// This is the world
			TmodelControl	*fMyControl;			// This is the model control
			Tcamera			*fMyCamera;			// This is the camera that


		//
		// Support picking
		void		BuildPickRay(CPoint);



		// support camera tracking and zooming
		Tvaluator   fXValuator;		// support zooming and tracking
		Tvaluator   fYValuator;
			
		//
		// Support rotating the models in the world
		int	fXPos, fYPos;
		float fXRot, fYRot;
		void BeginMouseRotation(const CString &, int x, int y);
		void UpdateMouseRotation(const CString &, int x, int y);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TD3DDRAWABLE_H__C2CBA7C9_F645_4E20_8CB6_4CBB67E7FDC7__INCLUDED_)
